version 1.40.130 release
[feisty_meow.git] / scripts / core / functions.sh
index fc5ce4ebc677daf6270acb850cda42688c803eaf..c5a4f87daa7cc153a4d3d471a9c0d6e70e80ac67 100644 (file)
@@ -33,6 +33,28 @@ if [ -z "$skip_all" ]; then
     date +"%Y$sep%m$sep%d$sep%H%M$sep%S" | tr -d '/\n/'
   }
   
+  # a wrapper for the which command that finds items on the path.  some OSes
+  # do not provide which, so we want to not be spewing errors when that
+  # happens.
+  function whichable()
+  {
+    to_find="$1"; shift
+    local WHICHER="$(\which which 2>/dev/null)"
+#>&2 echo "got whicher as: $WHICHER"
+    if [ $? -ne 0 ]; then
+      # there is no which command here.  we produce nothing due to this.
+      echo
+      return 2
+    fi
+    local sporkenz  # must be defined local here, before call, or we don't get exit value?!
+    sporkenz=$($WHICHER "$to_find" 2>/dev/null)
+#>&2 echo "broken with this line, but here is exit val: $?"
+    local err=$?
+#>&2 echo "got whicher as: $WHICHER"
+    echo $sporkenz
+    return $err
+  }
+
   # makes a directory of the name specified and then tries to change the
   # current directory to that directory.
   function mcd() {
@@ -40,15 +62,42 @@ if [ -z "$skip_all" ]; then
     cd "$1"
   }
 
+  # returns true if the variable is an array.
   function is_array() {
     [[ "$(declare -p $1)" =~ "declare -a" ]]
   }
 
+  # returns true if the name provided is a defined alias.
   function is_alias() {
     alias $1 &>/dev/null
     return $?
   }
 
+  # makes the status of pipe number N (passed as first parameter) into the
+  # main return value (i.e., the value for $?).  this is super handy to avoid
+  # repeating the awkward looking code below in multiple places.
+  function promote_pipe_return()
+  {
+    ( exit ${PIPESTATUS[$1]} )
+  }
+
+  ##############
+
+  function fm_username()
+  {
+    # see if we can get the user name from the login name.  oddly this sometimes doesn't work.
+    local custom_user="$(logname 2>/dev/null)"
+    if [ -z "$custom_user" ]; then
+      # try the normal unix user variable.
+      custom_user="$USER"
+    fi
+    if [ -z "$custom_user" ]; then
+      # try the windows user variable.
+      custom_user="$USERNAME"
+    fi
+    echo "$custom_user"
+  }
+
   ##############
 
   # displays the value of a variable in bash friendly format.
@@ -144,7 +193,7 @@ if [ -z "$skip_all" ]; then
   function exit_on_error()
   {
     if [ $? -ne 0 ]; then
-      echo -e "\n\naction failed: $*\n\n*** Exiting script..."
+      echo -e "\n\nan important action failed and this script will stop:\n\n$*\n\n*** Exiting script..."
       error_sound
       exit 1
     fi
@@ -154,55 +203,88 @@ if [ -z "$skip_all" ]; then
   function continue_on_error()
   {
     if [ $? -ne 0 ]; then
-      echo -e "\n\nerror occurred: $*\n\n=> Continuing script..."
+      echo -e "\n\na problem occurred, but we can continue:\n\n$*\n\n=> Continuing script..."
       error_sound
     fi
   }
 
   ##############
 
+  # accepts any number of arguments and outputs them to the feisty meow event log.
+  function log_feisty_meow_event()
+  {
+    echo -e "$(date_stringer) -- ${USER}@$(hostname): $*" >> "$FEISTY_MEOW_EVENT_LOG"
+  }
+
+  ##############
+
   # wraps secure shell with some parameters we like, most importantly to enable X forwarding.
   function ssh()
   {
-    local args=($*)
-    # we remember the old terminal title, then force the TERM variable to a more generic
-    # version for the other side (just 'linux'); we don't want the remote side still
-    # thinking it's running xterm.
-    save_terminal_title
-#hmmm: why were we doing this?  it scorches the user's logged in session, leaving it without proper terminal handling.
-#    # we save the value of TERM; we don't want to leave the user's terminal
-#    # brain dead once we come back from this function.
-#    local oldterm="$TERM"
-#    export TERM=linux
-    /usr/bin/ssh -X -C "${args[@]}"
-#    # restore the terminal variable also.
-#    TERM="$oldterm"
+    local args=($@)
+    save_terminal_title  # remember the current terminal title.
+    /usr/bin/ssh -C "${args[@]}"
+#hmmm: removed -Y flag because considered dangerous to trust remote hosts to not abuse our X session.
+    restore_terminal_title
+  }
+
+  # this version of ssh preserves the use of the -Y flag for when X forwarding is needed.
+  function yssh()
+  {
+    local args=($@)
+    save_terminal_title  # remember the current terminal title.
+    /usr/bin/ssh -Y "${args[@]}"
     restore_terminal_title
   }
 
   ##############
 
   # locates a process given a search pattern to match in the process list.
-  # supports a single command line flag style parameter of "-u USERNAME";
-  # if the -u flag is found, a username is expected afterwards, and only the
-  # processes of that user are considered.
+  #
+  # + the -u flag specifies a user name, e.g. "-u joe", which causes only
+  #   the processes of that user "joe" to be considered.
+  #
+  # + the -x flag specifies a pattern to exclude from the list, e.g. "-x pszap.sh"
+  #   would ignore any processes that mention the phrase "pszap.sh".
   function psfind() {
+    local user_flag="-e"
+      # default user flag is for all users.
+    local excluder="ScrengeflebbitsAPhraseWeNeverExpecttomatchanythingYO298238"
+      # for our default, pick an exclusion string we would never match.
+
+    local found_flag=1
+    while [ $found_flag -eq 1 ]; do
+      # reset our sentinel now that we're safely in our loop.
+      found_flag=0
+
+      # save the first argument, since we're going to shift the args.
+      local arg1="$1"
+      if [ "$arg1" == "-u" ]; then
+        # handle the user flag.
+        user_flag="-u $2" 
+#echo "found a -u parm and user=$2" 
+        found_flag=1  # signal that we found one.
+        # skip these two arguments, since we've consumed them.
+        shift
+        shift
+      elif [ "$arg1" == "-x" ]; then
+        # handle the exclusion flag.
+        excluder="$2" 
+#echo "found a -x parm and excluder=$excluder" 
+        found_flag=1  # signal that we found one.
+        # skip these two arguments, since we've consumed them.
+        shift
+        shift
+      fi
+    done
+
+    # now that we've yanked any flags out, we can pull the rest of the
+    # arguments in as patterns to seek in the process list.
     local -a patterns=("${@}")
 #echo ====
 #echo patterns list is: "${patterns[@]}"
 #echo ====
 
-    local user_flag
-    if [ "${patterns[0]}" == "-u" ]; then
-      user_flag="-u ${patterns[1]}" 
-#echo "found a -u parm and user=${patterns[1]}" 
-      # void the two elements with that user flag so we don't use them as patterns.
-      unset patterns[0] patterns[1]=
-    else
-      # select all users.
-      user_flag="-e"
-    fi
-
     local PID_DUMP="$(mktemp "$TMP/zz_pidlist.XXXXXX")"
     local -a PIDS_SOUGHT
 
@@ -231,8 +313,10 @@ if [ -z "$skip_all" ]; then
     # ids out of the results.
     local i
     for i in "${patterns[@]}"; do
+#echo "pattern curr is '$i'"
       PIDS_SOUGHT+=($(cat $PID_DUMP \
         | grep -i "$i" \
+        | grep -v "$excluder" \
         | sed -n -e "$pid_finder_pattern"))
     done
 #echo ====
@@ -313,22 +397,6 @@ if [ -z "$skip_all" ]; then
     done
   }
   
-#hmmm: not really doing anything yet; ubuntu seems to have changed from pulseaudio in 17.04?
-  # restarts the sound driver.
-  function fix_sound_driver() {
-    # stop bash complaining about blank function body.
-    local nothing=
-#if alsa something
-#    sudo service alsasound restart
-#elif pulse something
-#    sudo pulseaudio -k
-#    sudo pulseaudio -D
-#else
-#    something else...?
-#fi
-
-  }
-
   function screen() {
     save_terminal_title
 #hmmm: ugly absolute path here.
@@ -358,13 +426,13 @@ if [ -z "$skip_all" ]; then
     fi
   }
   
-  # switches from an X:/ form to a /cygdrive/X/path form.  this is only useful
-  # for the cygwin environment currently.
-  function dos_to_unix_path() {
-    # we always remove dos slashes in favor of forward slashes.
-#old:    echo "$1" | sed -e 's/\\/\//g' | sed -e 's/\([a-zA-Z]\):\/\(.*\)/\/\1\/\2/'
-         echo "$1" | sed -e 's/\\/\//g' | sed -e 's/\([a-zA-Z]\):\/\(.*\)/\/cygdrive\/\1\/\2/'
-  }
+#  # switches from an X:/ form to a /cygdrive/X/path form.  this is only useful
+#  # for the cygwin environment currently.
+#  function dos_to_unix_path() {
+#    # we always remove dos slashes in favor of forward slashes.
+##old:    echo "$1" | sed -e 's/\\/\//g' | sed -e 's/\([a-zA-Z]\):\/\(.*\)/\/\1\/\2/'
+#         echo "$1" | sed -e 's/\\/\//g' | sed -e 's/\([a-zA-Z]\):\/\(.*\)/\/cygdrive\/\1\/\2/'
+#  }
 
   # returns a successful value (0) if this system is debian or ubuntu.
   function debian_like() {
@@ -380,42 +448,35 @@ if [ -z "$skip_all" ]; then
     fi
   }
   
-  # su function: makes su perform a login.
-  # for some OSes, this transfers the X authority information to the new login.
-  function su() {
-    if debian_like; then
-      # debian currently requires the full version which imports X authority
-      # information for su.
-  
-      # get the x authority info for our current user.
-      source "$FEISTY_MEOW_SCRIPTS/security/get_x_auth.sh"
-  
-      if [ -z "$X_auth_info" ]; then
-        # if there's no authentication info to pass along, we just do a normal su.
-        /bin/su -l $*
-      else
-        # under X, we update the new login's authority info with the previous
-        # user's info.
-        (unset XAUTHORITY; /bin/su -l $* -c "$X_auth_info ; export DISPLAY=$DISPLAY ; bash")
-      fi
-    else
-      # non-debian supposedly doesn't need the extra overhead any more.
-      # or at least suse doesn't, which is the other one we've tested on.
-      /bin/su -l $*
-    fi
-  }
-  
-  # sudo function wraps the normal sudo by ensuring we replace the terminal
-  # label if they're doing an su with the sudo.
+  # this function wraps the normal sudo by ensuring we replace the terminal
+  # label before we launch what they're passing to sudo.  we also preserve
+  # specific variables that enable the main user's ssh credentials to still
+  # be relied on for ssh forwarding, even if the '-i' flag is passed to cause
+  # a fresh shell (which normally doesn't get the launching user's environment
+  # variables).
   function sudo() {
     save_terminal_title
-    /usr/bin/sudo "$@"
+
+    # hoist our X authorization info in case environment is passed along;
+    # this can allow root to use our display to show X.org windows.
+    if [ -z "$IMPORTED_XAUTH" -a ! -z "$DISPLAY" ]; then
+      export IMPORTED_XAUTH="$(xauth list $DISPLAY | head -n 1 | awk '{print $3}')"
+      local REMOVE_IMP_XAUTH=true
+    fi
+
+    # launch sudo with just the variables we want to reach the other side.
+    local varmods=
+    varmods+="OLD_HOME=$HOME "
+    if [ ! -z "$IMPORTED_XAUTH" ]; then varmods+="IMPORTED_XAUTH=$IMPORTED_XAUTH "; fi
+    if [ ! -z "$SSH_AUTH_SOCK" ]; then varmods+="SSH_AUTH_SOCK=$SSH_AUTH_SOCK "; fi
+    /usr/bin/sudo $varmods "$@"
     retval=$?
+
+    # take the xauth info away again if it wasn't set already.
+    if [ ! -z "$REMOVE_IMP_XAUTH" ]; then
+      unset IMPORTED_XAUTH
+    fi
     restore_terminal_title
-#    if [ "$first_command" == "su" ]; then
-#      # yep, they were doing an su, but they're back now.
-#      label_terminal_with_info
-#    fi
     return $retval
   }
   
@@ -429,7 +490,7 @@ if [ -z "$skip_all" ]; then
 
   # overlay for nechung binary so that we can complain less grossly about it when it's missing.
   function nechung() {
-    local wheres_nechung=$(which nechung 2>/dev/null)
+    local wheres_nechung=$(whichable nechung)
     if [ -z "$wheres_nechung" ]; then
       echo "The nechung oracle program cannot be found.  You may want to consider"
       echo "rebuilding the feisty meow applications with this command:"
@@ -448,82 +509,96 @@ if [ -z "$skip_all" ]; then
     bash $FEISTY_MEOW_SCRIPTS/core/reconfigure_feisty_meow.sh
     echo
     # force a full reload by turning off sentinel variables and methods.
-    unset -v CORE_VARIABLES_LOADED FEISTY_MEOW_LOADING_DOCK USER_CUSTOMIZATIONS_LOADED
+    unset -v CORE_VARIABLES_LOADED FEISTY_MEOW_LOADING_DOCK USER_CUSTOMIZATIONS_LOADED \
+        BUILD_VARS_LOADED
     unalias CORE_ALIASES_LOADED &>/dev/null
     unset -f function_sentinel 
+
+    # reuse the original path if we can.
+    if [ ! -z "$FEISTY_MEOW_ORIGINAL_PATH" ]; then
+      export PATH="$FEISTY_MEOW_ORIGINAL_PATH"
+    fi
+
     # reload feisty meow environment in current shell.
-    echo "reloading the feisty meow scripts."
-    echo
+    log_feisty_meow_event "reloading the feisty meow scripts for $USER in current shell."
     source "$FEISTY_MEOW_SCRIPTS/core/launch_feisty_meow.sh"
     # run nechung oracle to give user a new fortune.
     nechung
     restore_terminal_title
   }
 
-  # copies a set of custom scripts into the proper location for feisty meow
-  # to merge their functions and aliases with the standard set.
+  # merges a set of custom scripts into the feisty meow environment.  can be
+  # passed a name to use as the custom scripts source folder (found on path
+  # $FEISTY_MEOW_SCRIPTS/customize/{name}), or it will try to guess the name
+  # by using the login name.
   function recustomize()
   {
     local custom_user="$1"; shift
     if [ -z "$custom_user" ]; then
-      # use our default example user if there was no name provided.
-      custom_user=$(logname)
+      # default to login name if there was no name provided.
+      custom_user="$(fm_username)"
+        # we do intend to use the login name here to get the login name and to ignore
+        # if the user has sudo root access; we don't want to provide a custom
+        # profile for root.
     fi
+    # chop off any email address style formatting to leave just the name.
+    custom_user="$(echo "$custom_user" | cut -f1 -d'@')"
 
     save_terminal_title
 
     if [ ! -d "$FEISTY_MEOW_SCRIPTS/customize/$custom_user" ]; then
-      echo "The customization folder for '$custom_user' would be:"
-      echo "  $FEISTY_MEOW_SCRIPTS/customize/$custom_user"
-      echo "but that folder does not exist.  Skipping recustomization."
+      echo -e "the customization folder for '$custom_user' is missing:
+
+    $FEISTY_MEOW_SCRIPTS/customize/$custom_user
+
+we will skip recustomization, but these other customizations are available:
+"
+      # a little tr and sed magic to fix the carriage returns into commas.
+      local line="$(find $FEISTY_MEOW_SCRIPTS/customize -mindepth 1 -maxdepth 1 -type d -exec basename {} ';' | tr '\n' '&' | sed 's/&/, /g' | sed -e 's/, $//')"
+        # make the line feeds and carriage returns manageable with tr.
+        # convert the ampersand, our weird replacement for EOL, with a comma + space in sed.
+        # last touch with sed removes the last comma.
+      echo "    $line"
       return 1
     fi
 
-    # prevent permission foul-ups.
-#hmmm: save error output here instead of muting it.
-#hmmm: better yet actually, just don't complain on freaking cygwin, since that's where this happens
-    chown -R "$(logname):$(logname)" \
-        "$FEISTY_MEOW_LOADING_DOCK"/* "$FEISTY_MEOW_GENERATED_STORE"/* 2>/dev/null
-    continue_on_error "chowning to $(logname) didn't happen."
-
+    # recreate the feisty meow loading dock.
     regenerate >/dev/null
-    pushd "$FEISTY_MEOW_LOADING_DOCK/custom" &>/dev/null
-    incongruous_files="$(bash "$FEISTY_MEOW_SCRIPTS/files/list_non_dupes.sh" "$FEISTY_MEOW_SCRIPTS/customize/$custom_user" "$FEISTY_MEOW_LOADING_DOCK/custom")"
-
-    local fail_message="\n
-are the perl dependencies installed?  if you're on ubuntu or debian, try this:\n
-    $(grep "apt-get.*perl" $FEISTY_MEOW_APEX/readme.txt)\n
-or if you're on cygwin, then try this (if apt-cyg is available):\n
-    $(grep "apt-cyg.*perl" $FEISTY_MEOW_APEX/readme.txt)\n";
-
-    #echo "the incongruous files list is: $incongruous_files"
-    # disallow a single character result, since we get "*" as result when nothing exists yet.
-    if [ ${#incongruous_files} -ge 2 ]; then
-      echo "cleaning unknown older overrides..."
-      perl "$FEISTY_MEOW_SCRIPTS/files/safedel.pl" $incongruous_files
-      continue_on_error "running safedel.  $fail_message" 
-      echo
+
+    # jump into the loading dock and make our custom link.
+    pushd "$FEISTY_MEOW_LOADING_DOCK" &>/dev/null
+    if [ -h custom ]; then
+      # there's an existing link, so remove it.
+      \rm custom
+    fi
+    # make sure we cleaned up the area before we re-link.
+    if [ -h custom -o -d custom -o -f custom ]; then
+      echo "
+Due to an over-abundance of caution, we are not going to remove an unexpected
+'custom' object found in the file system.  This object is located in the
+feisty meow loading dock here: $(pwd)
+And here is a description of the rogue 'custom' object:
+"
+      ls -al custom
+      echo "
+If you are pretty sure that this is just a remnant of an older approach in
+feisty meow, where we copied the custom directory rather than linking it
+(and it most likely is just such a bit of cruft of that nature), then please
+remove that old remnant 'custom' item, for example by saying:
+  /bin/rm -rf \"custom\" ; popd
+Sorry for the interruption, but we want to make sure this removal wasn't
+automatic if there is even a small amount of doubt about the issue."
+      return 1
     fi
+
+    # create the custom folder as a link to the customizations.
+    ln -s "$FEISTY_MEOW_SCRIPTS/customize/$custom_user" custom
+
     popd &>/dev/null
-    echo "copying custom overrides for $custom_user"
-    mkdir -p "$FEISTY_MEOW_LOADING_DOCK/custom" 2>/dev/null
-    perl "$FEISTY_MEOW_SCRIPTS/text/cpdiff.pl" "$FEISTY_MEOW_SCRIPTS/customize/$custom_user" "$FEISTY_MEOW_LOADING_DOCK/custom"
-    continue_on_error "running cpdiff.  $fail_message"
 
-    if [ -d "$FEISTY_MEOW_SCRIPTS/customize/$custom_user/scripts" ]; then
-      echo "copying custom scripts for $custom_user"
-      rsync -avz "$FEISTY_MEOW_SCRIPTS/customize/$custom_user/scripts" "$FEISTY_MEOW_LOADING_DOCK/custom/" &>/dev/null
-      continue_on_error "copying customization scripts"
-#hmmm: could save output to show if an error occurs.
-    fi
-    echo
+    # now take into account all the customizations by regenerating the feisty meow environment.
     regenerate
 
-    # prevent permission foul-ups, again.
-    chown -R "$(logname):$(logname)" \
-        "$FEISTY_MEOW_LOADING_DOCK" "$FEISTY_MEOW_GENERATED_STORE" 2>/dev/null
-    continue_on_error "chowning to $(logname) didn't happen."
-
     restore_terminal_title
   }
 
@@ -538,24 +613,9 @@ or if you're on cygwin, then try this (if apt-cyg is available):\n
     echo
   }
 
-  # a wrapper for the which command that finds items on the path.  some OSes
-  # do not provide which, so we want to not be spewing errors when that
-  # happens.
-  function whichable()
-  {
-    to_find="$1"; shift
-    which which &>/dev/null
-    if [ $? -ne 0 ]; then
-      # there is no which command here.  we produce nothing due to this.
-      echo
-    fi
-    echo $(which $to_find)
-  }
-
-#hmmm: improve this by not adding the link
-# if already there, or if the drive is not valid.
   function add_cygwin_drive_mounts() {
     for i in c d e f g h q z ; do
+#hmmm: improve this by not adding the link if already there, or if the drive is not valid.
       ln -s /cygdrive/$i $i
     done
   }
@@ -675,49 +735,6 @@ or if you're on cygwin, then try this (if apt-cyg is available):\n
     popd &>/dev/null
   }
 
-  function spacem()
-  {
-    while [ $# -gt 0 ]; do
-      arg="$1"; shift
-      if [ ! -f "$arg" -a ! -d "$arg" ]; then
-        echo "failure to find a file or directory named '$arg'."
-        continue
-      fi
-
-      # first we will capture the output of the character replacement operation for reporting.
-      # this is done first since some filenames can't be properly renamed in perl (e.g. if they
-      # have pipe characters apparently).
-      intermediate_name="$(bash "$FEISTY_MEOW_SCRIPTS/files/replace_spaces_with_underscores.sh" "$arg")"
-      local saw_intermediate_result=0
-      if [ -z "$intermediate_name" ]; then
-        # make sure we report something, if there are no further name changes.
-        intermediate_name="'$arg'"
-      else 
-        # now zap the first part of the name off (since original name isn't needed).
-        intermediate_name="$(echo $intermediate_name | sed -e 's/.*=> //')"
-        saw_intermediate_result=1
-      fi
-
-      # first we rename the file to be lower case.
-      actual_file="$(echo $intermediate_name | sed -e "s/'\([^']*\)'/\1/")"
-      final_name="$(perl $FEISTY_MEOW_SCRIPTS/files/renlower.pl "$actual_file")"
-      local saw_final_result=0
-      if [ -z "$final_name" ]; then
-        final_name="$intermediate_name"
-      else
-        final_name="$(echo $final_name | sed -e 's/.*=> //')"
-        saw_final_result=1
-      fi
-#echo intermed=$saw_intermediate_result 
-#echo final=$saw_final_result 
-
-      if [[ $saw_intermediate_result != 0 || $saw_final_result != 0 ]]; then
-        # printout the combined operation results.
-        echo "'$arg' => $final_name"
-      fi
-    done
-  }
-
   ##############
 
 # new breed of definer functions goes here.  still in progress.
@@ -759,11 +776,11 @@ return 0
   {
     count=$1; shift
     if [ -z "$count" ]; then
-      count=79
+      count=$(($COLUMNS - 1))
     fi
     echo
     local i
-    for ((i=0; i < $count - 1; i++)); do
+    for ((i=0; i < $count; i++)); do
       echo -n "="
     done
     echo
@@ -851,7 +868,7 @@ return 0
       this_host=$(hostname)
     elif [ ! -z "$(echo $MACHTYPE | grep suse)" ]; then
       this_host=$(hostname --long)
-    elif [ -x "$(which hostname 2>/dev/null)" ]; then
+    elif [ -x "$(whichable hostname)" ]; then
       this_host=$(hostname)
     fi
     echo "$this_host"
@@ -930,7 +947,49 @@ return 0
 
   ##############
 
-  # site avenger aliases
+  # space 'em all: fixes naming for all of the files of the appropriate types
+  # in the directories specified.  we skip any file with a dot in front, to
+  # respect their hidden nature.  currently the set of files we'll rename is
+  # very boutique; it's in this function, and just happens to be the types of
+  # files we work with a lot.
+  function spacemall() {
+    local -a dirs=("${@}")
+    if [ ${#dirs[@]} -eq 0 ]; then
+      dirs=(.)
+    fi
+
+    local charnfile="$(mktemp $TMP/zz_charn.XXXXXX)"
+#hmmm: any way to do the below more nicely or reusably?
+#hmmm: yes!  a variable with a list of files that are considered TEXT_FILE_EXTENSIONS or something like that.
+#hmmm: yes continued!  also a variable for BINARY_FILE_EXTENSIONS to avoid those, where we need to in other scripts.
+#hmmm: wait, we actually have a mix here, since this is a renaming function and not a searching function; get it straight!
+#hmmm: would the composition of those two types of extensions cover all the files i want to rename?  they have to be "important".
+    find "${dirs[@]}" -follow -maxdepth 1 -mindepth 1 -type f -and -not -iname ".[a-zA-Z0-9]*" | \
+        grep -i \
+"csv\|doc\|docx\|eml\|html\|jpeg\|jpg\|m4a\|mov\|mp3\|odp\|ods\|odt\|pdf\|png\|ppt\|pptx\|rtf\|txt\|vsd\|vsdx\|wav\|xls\|xlsx\|xml\|zip" | \
+        sed -e 's/^/"/' | sed -e 's/$/"/' | \
+        xargs bash "$FEISTY_MEOW_SCRIPTS/files/spacem.sh"
+    # drop the temp file now that we're done.
+    rm "$charnfile"
+  }
+
+  ##############
+
+  # tty relevant functions...
+
+  # keep_awake: sends a message to the screen from the background.
+  function keep_awake()
+  {
+    # just starts the keep_awake process in the background.
+    bash $FEISTY_MEOW_SCRIPTS/tty/keep_awake_process.sh &
+      # this should leave the job running as %1 or a higher number if there
+      # are pre-existing background jobs.
+  }
+
+  ##############
+
+  # site avenger functions...
+
   function switchto()
   {
     THISDIR="$FEISTY_MEOW_SCRIPTS/site_avenger"
@@ -940,6 +999,28 @@ return 0
 
   ##############
 
+  # you have hit the borderline functional zone...
+
+#hmmm: not really doing anything yet; ubuntu seems to have changed from pulseaudio in 17.04?
+  # restarts the sound driver.
+  function fix_sound_driver() {
+    # stop bash complaining about blank function body.
+    local nothing=
+#if alsa something
+#    sudo service alsasound restart
+#elif pulse something
+#    sudo pulseaudio -k
+#    sudo pulseaudio -D
+#else
+#    something else...?
+#fi
+
+  }
+
+  # ...and here's the end of the borderline functional zone.
+
+  ##############
+
   # NOTE: no more function definitions are allowed after this point.
 
   function function_sentinel()